Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 34061)
+++ channels/chan_sip.c	(working copy)
@@ -871,7 +871,9 @@
 		AST_STRING_FIELD(rpid);		/*!< Our RPID header */
 		AST_STRING_FIELD(rpid_from);	/*!< Our RPID From header */
 	);
-	struct ast_codec_pref prefs;		/*!< codec prefs */
+	struct ast_codec_pref userprefs;	/*!< user codec prefs */
+	int usercapability;                     /*!< user capabilities */
+	struct ast_codec_pref formats;          /*!< current channel formats */
 	unsigned int ocseq;			/*!< Current outgoing seqno */
 	unsigned int icseq;			/*!< Current incoming seqno */
 	ast_group_t callgroup;			/*!< Call group */
@@ -880,12 +882,7 @@
 	struct ast_flags flags[2];		/*!< SIP_ flags */
 	int timer_t1;				/*!< SIP timer T1, ms rtt */
 	unsigned int sipoptions;		/*!< Supported SIP sipoptions on the other end */
-	int capability;				/*!< Special capability (codec) */
-	int jointcapability;			/*!< Supported capability at both ends (codecs ) */
-	int peercapability;			/*!< Supported peer capability */
-	int prefcodec;				/*!< Preferred codec (outbound only) */
 	int noncodeccapability;			/*!< DTMF RFC2833 telephony-event */
-	int redircodecs;			/*!< Redirect codecs */
 	int maxcallbitrate;			/*!< Maximum Call Bitrate for Video Calls */	
 	struct t38properties t38;		/*!< T38 settings */
 	struct sockaddr_in udptlredirip;	/*!< Where our T.38 UDPTL should be going if not to us */
@@ -900,6 +897,7 @@
 	struct sockaddr_in sa;			/*!< Our peer */
 	struct sockaddr_in redirip;		/*!< Where our RTP should be going if not to us */
 	struct sockaddr_in vredirip;		/*!< Where our Video RTP should be going if not to us */
+	struct ast_codec_pref redircodecs;	/*!< Redirect codecs */
 	struct sockaddr_in recv;		/*!< Received as */
 	struct in_addr ourip;			/*!< Our IP */
 	struct ast_channel *owner;		/*!< Who owns us */
@@ -1126,7 +1124,7 @@
 	in coming releases */
 
 /*--- PBX interface functions */
-static struct ast_channel *sip_request_call(const char *type, int format, void *data, int *cause);
+static struct ast_channel *sip_request_call(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int sip_devicestate(void *data);
 static int sip_sendtext(struct ast_channel *ast, const char *text);
 static int sip_call(struct ast_channel *ast, char *dest, int timeout);
@@ -1376,6 +1374,7 @@
 /*--- Parsing SIP requests and responses */
 static void append_date(struct sip_request *req);	/* Append date to SIP packet */
 static int determine_firstline_parts(struct sip_request *req);
+static void sip_fixup_codecs(struct ast_channel *chan, const struct ast_codec_pref *peer_codecs);
 static const struct cfsubscription_types *find_subscription_type(enum subscriptiontype subtype);
 static const char *gettag(const struct sip_request *req, const char *header, char *tagbuf, int tagbufsize);
 static int find_sip_method(const char *msg);
@@ -1458,10 +1457,9 @@
 static void handle_response(struct sip_pvt *p, int resp, char *rest, struct sip_request *req, int ignore, int seqno);
 
 /*----- RTP interface functions */
-static int sip_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, int codecs, int nat_active);
+static int sip_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, const struct ast_codec_pref *codecs, int nat_active);
 static struct ast_rtp *sip_get_rtp_peer(struct ast_channel *chan);
 static struct ast_rtp *sip_get_vrtp_peer(struct ast_channel *chan);
-static int sip_get_codec(struct ast_channel *chan);
 static struct ast_frame *sip_rtp_read(struct ast_channel *ast, struct sip_pvt *p, int *faxdetect);
 
 /*------ T38 Support --------- */
@@ -1475,7 +1473,7 @@
 static const struct ast_channel_tech sip_tech = {
 	.type = "SIP",
 	.description = "Session Initiation Protocol (SIP)",
-	.capabilities = ((AST_FORMAT_MAX_AUDIO << 1) - 1),
+	.capabilities = ((AST_FORMAT_MAX_VIDEO << 1) - 1),
 	.properties = AST_CHAN_TP_WANTSJITTER | AST_CHAN_TP_CREATESJITTER,
 	.requester = sip_request_call,
 	.devicestate = sip_devicestate,
@@ -1491,6 +1489,7 @@
 	.send_digit = sip_senddigit,
 	.bridge = ast_rtp_bridge,
 	.send_text = sip_sendtext,
+	.fixup_codecs = sip_fixup_codecs,
 };
 
 /**--- some list management macros. **/
@@ -1508,7 +1507,6 @@
 	get_rtp_info: sip_get_rtp_peer,
 	get_vrtp_info: sip_get_vrtp_peer,
 	set_rtp_peer: sip_set_rtp_peer,
-	get_codec: sip_get_codec,
 };
 
 /*! \brief Interface structure with callbacks used to connect to UDPTL module*/
@@ -2447,12 +2445,11 @@
 
 	ast_copy_flags(&r->flags[0], &peer->flags[0], SIP_FLAGS_TO_COPY);
 	ast_copy_flags(&r->flags[1], &peer->flags[1], SIP_PAGE2_FLAGS_TO_COPY);
-	r->capability = peer->capability;
 	if (!ast_test_flag(&r->flags[1], SIP_PAGE2_VIDEOSUPPORT) && r->vrtp) {
 		ast_rtp_destroy(r->vrtp);
 		r->vrtp = NULL;
 	}
-	r->prefs = peer->prefs;
+	r->userprefs = peer->prefs;
 	if (ast_test_flag(&r->flags[1], SIP_PAGE2_T38SUPPORT)) {
 		r->t38.capability = global_t38_capability;
 		if (r->udptl) {
@@ -2681,7 +2678,6 @@
 	res = update_call_counter(p, INC_CALL_RINGING);
 	if ( res != -1 ) {
 		p->callingpres = ast->cid.cid_pres;
-		p->jointcapability = p->capability;
 		p->t38.jointcapability = p->t38.capability;
 		if (option_debug)
 			ast_log(LOG_DEBUG,"Our T38 capability (%d), joint T38 capability (%d)\n", p->t38.capability, p->t38.jointcapability);
@@ -3256,12 +3252,19 @@
 
 	fmt = ast_getformatbyname(codec);
 	if (fmt) {
-		ast_log(LOG_NOTICE, "Changing codec to '%s' for this call because of ${SIP_CODEC) variable\n", codec);
-		if (p->jointcapability & fmt) {
-			p->jointcapability &= fmt;
-			p->capability &= fmt;
+		if (fmt & p->usercapability)
+		{
+			ast_log(LOG_NOTICE, "Changing codec to '%s' for this call because of ${SIP_CODEC) variable\n", codec);
+			if (ast_codec_pref_bits(&p->formats) & fmt) {
+				ast_codec_pref_remove(&p->formats, ~fmt);
+				if (p->owner) {
+					memcpy(&p->owner->nativeformats, &p->formats, sizeof(p->formats));
+				}
+
+			} else
+				ast_log(LOG_NOTICE, "Ignoring ${SIP_CODEC} variable because it is not shared by both ends.\n");
 		} else
-			ast_log(LOG_NOTICE, "Ignoring ${SIP_CODEC} variable because it is not shared by both ends.\n");
+			ast_log(LOG_NOTICE, "Ignoring ${SIP_CODEC} variable because codec %s is disallowed by user preferences.\n", codec);
 	} else
 		ast_log(LOG_NOTICE, "Ignoring ${SIP_CODEC} variable because of unrecognized/not configured codec (check allow/disallow in sip.conf): %s\n", codec);
 	return;	
@@ -3302,9 +3305,9 @@
 
 	switch (frame->frametype) {
 	case AST_FRAME_VOICE:
-		if (!(frame->subclass & ast->nativeformats)) {
+		if (!(frame->subclass & ast->nativeformats.audio_bits)) {
 			ast_log(LOG_WARNING, "Asked to transmit frame type %d, while native formats is %d (read/write = %d/%d)\n",
-				frame->subclass, ast->nativeformats, ast->readformat, ast->writeformat);
+				frame->subclass, ast->nativeformats.audio_bits, ast->readformat, ast->writeformat);
 			return 0;
 		}
 		if (p) {
@@ -3314,6 +3317,9 @@
 				if ((ast->_state != AST_STATE_UP) &&
 				    !ast_test_flag(&p->flags[0], SIP_PROGRESS_SENT) &&
 				    !ast_test_flag(&p->flags[0], SIP_OUTGOING)) {
+					int compatible_codecs = ast_compatible_audio_formats(frame->subclass) | ast->nativeformats.video_bits;
+					ast_codec_pref_remove2(&ast->nativeformats, ~compatible_codecs);
+					ast_codec_pref_remove2(&p->formats, ~compatible_codecs);
 					transmit_response_with_sdp(p, "183 Session Progress", &p->initreq, XMIT_UNRELIABLE);
 					ast_set_flag(&p->flags[0], SIP_PROGRESS_SENT);	
 				}
@@ -3536,7 +3542,29 @@
 	return res;
 }
 
-
+/*--- sip_fixup_codecs: try to fixup codec list
+*/
+static void sip_fixup_codecs(struct ast_channel *chan, const struct ast_codec_pref *peer_codecs)
+{
+	struct sip_pvt *p = chan->tech_pvt;
+	int codecs_to_preserve;
+	ast_mutex_lock(&p->lock);
+	if (!ast_test_flag(&p->flags[0], SIP_OUTGOING)) {
+		/* This is incoming call so its codec list is to be reordered */
+		codecs_to_preserve = ast_codec_pref_bits(&chan->nativeformats);
+		memcpy(&chan->nativeformats, peer_codecs, sizeof(chan->nativeformats));
+	}
+	else {
+		codecs_to_preserve = ast_codec_pref_bits(peer_codecs);
+	}
+	ast_codec_pref_remove2(&chan->nativeformats, ~codecs_to_preserve);
+	memcpy(&p->formats, &chan->nativeformats, sizeof(chan->nativeformats));
+	ast_codec_pref_remove2(&p->formats, ~p->usercapability);
+	if (AST_STATE_UP == chan->_state) {
+		transmit_reinvite_with_sdp(p);
+	}
+	ast_mutex_unlock(&p->lock);
+}
 
 /*! \brief Initiate a call in the SIP channel
 	called from sip_request_call (calls from the pbx ) for outbound channels
@@ -3548,7 +3576,6 @@
 	struct ast_channel *tmp;
 	struct ast_variable *v = NULL;
 	int fmt;
-	int what;
 	int needvideo = 0;
 	
 	ast_mutex_unlock(&i->lock);
@@ -3563,38 +3590,13 @@
 
 	/* Select our native format based on codec preference until we receive
 	   something from another device to the contrary. */
-	if (i->jointcapability)	 	/* The joint capabilities of us and peer */
-		what = i->jointcapability;
-	else if (i->capability)		/* Our configured capability for this peer */
-		what = i->capability;
-	else
-		what = global_capability;	/* Global codec support */
+	memcpy(&tmp->nativeformats, &i->formats, sizeof(i->formats));
 
-	/* Set the native formats for audio  and merge in video */
-	tmp->nativeformats = ast_codec_choose(&i->prefs, what, 1) | (i->jointcapability & AST_FORMAT_VIDEO_MASK);
-	if (option_debug > 2) {
-		char buf[BUFSIZ];
-		ast_log(LOG_DEBUG, "*** Our native formats are %s \n", ast_getformatname_multiple(buf, BUFSIZ, tmp->nativeformats));
-		ast_log(LOG_DEBUG, "*** Joint capabilities are %s \n", ast_getformatname_multiple(buf, BUFSIZ, i->jointcapability));
-		ast_log(LOG_DEBUG, "*** Our capabilities are %s \n", ast_getformatname_multiple(buf, BUFSIZ, i->capability));
-		ast_log(LOG_DEBUG, "*** AST_CODEC_CHOOSE formats are %s \n", ast_getformatname_multiple(buf, BUFSIZ, ast_codec_choose(&i->prefs, what, 1)));
-		if (i->prefcodec)
-			ast_log(LOG_DEBUG, "*** Our preferred formats from the incoming channel are %s \n", ast_getformatname_multiple(buf, BUFSIZ, i->prefcodec));
-	}
+	ast_codec_pref_remove2(&tmp->nativeformats, ~i->usercapability);
+	fmt = ast_codec_pref_index_audio(&tmp->nativeformats, 0);
 
-	/* XXX Why are we choosing a codec from the native formats?? */
-	fmt = ast_best_codec(tmp->nativeformats);
-
-	/* If we have a prefcodec setting, we have an inbound channel that set a 
-	   preferred format for this call. Otherwise, we check the jointcapability
-	   We also check for vrtp. If it's not there, we are not allowed do any video anyway.
-	 */
-	if (i->vrtp) {
-		if (i->prefcodec)
-			needvideo = i->prefcodec & AST_FORMAT_VIDEO_MASK;	/* Outbound call */
- 		else
-			needvideo = i->jointcapability & AST_FORMAT_VIDEO_MASK;	/* Inbound call */
-	}
+	if (i->vrtp)
+		needvideo = ast_codec_pref_bits(&i->formats) & AST_FORMAT_VIDEO_MASK;
 
 	if (option_debug > 2) {
 		if (needvideo) 
@@ -3858,10 +3860,10 @@
 	if (p->owner) {
 		/* We already hold the channel lock */
 		if (f->frametype == AST_FRAME_VOICE) {
-			if (f->subclass != (p->owner->nativeformats & AST_FORMAT_AUDIO_MASK)) {
+			if (!(f->subclass & p->owner->nativeformats.audio_bits)) {
 				if (option_debug)
 					ast_log(LOG_DEBUG, "Oooh, format changed to %d\n", f->subclass);
-				p->owner->nativeformats = (p->owner->nativeformats & AST_FORMAT_VIDEO_MASK) | f->subclass;
+				ast_codec_pref_append(&p->owner->nativeformats, f->subclass);
 				ast_set_read_format(p->owner, p->owner->readformat);
 				ast_set_write_format(p->owner, p->owner->writeformat);
 			}
@@ -3980,7 +3982,8 @@
 	p->autokillid = -1;
 	p->subscribed = NONE;
 	p->stateid = -1;
-	p->prefs = default_prefs;		/* Set default codecs for this call */
+	p->userprefs = default_prefs;		/* Set default codecs for this call */
+	p->usercapability = global_capability;
 
 	if (intended_method != SIP_OPTIONS)	/* Peerpoke has it's own system */
 		p->timer_t1 = 500;	/* Default SIP retransmission timer T1 (RFC 3261) */
@@ -4056,7 +4059,6 @@
 		ast_string_field_set(p, callid, callid);
 	/* Assign default music on hold class */
 	ast_string_field_set(p, musicclass, default_musicclass);
-	p->capability = global_capability;
 	p->allowtransfer = global_allowtransfer;
 	if ((ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_RFC2833) ||
 	    (ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_AUTO))
@@ -4451,9 +4453,11 @@
 	int sendonly = 0;
 	int numberofports;
 	struct ast_channel *bridgepeer = NULL;
+	int codec_index = 0;
+	int codec_pt_order[256];
+	int x;
+
 	struct ast_rtp *newaudiortp, *newvideortp;	/* Buffers for codec handling */
-	int newjointcapability;				/* Negotiated capability */
-	int newpeercapability;
 	int newnoncodeccapability;
 	int numberofmediastreams = 0;
 	int debug = sip_debug_test_pvt(p);
@@ -4527,6 +4531,8 @@
 				if (debug)
 					ast_verbose("Found RTP audio format %d\n", codec);
 				ast_rtp_set_m_type(newaudiortp, codec);
+				codec_pt_order[codec_index++] = codec;
+				codecs = ast_skip_blanks(codecs + len);
 			}
 		} else if ((sscanf(m, "video %d/%d RTP/AVP %n", &x, &numberofports, &len) == 2) ||
 		    (sscanf(m, "video %d RTP/AVP %n", &x, &len) == 1)) {
@@ -4542,6 +4548,8 @@
 				if (debug)
 					ast_verbose("Found RTP video format %d\n", codec);
 				ast_rtp_set_m_type(newvideortp, codec);
+				codec_pt_order[codec_index++] = codec;
+				codecs = ast_skip_blanks(codecs + len);
 			}
 		} else if (p->udptl && (sscanf(m, "image %d udptl t38 %n", &x, &len) == 1)) {
 			if (debug)
@@ -4688,6 +4696,17 @@
 		if (p->vrtp)
 			ast_rtp_set_rtpmap_type(newvideortp, codec, "video", mimeSubtype);
 	}
+        ast_codec_pref_init(&p->formats);
+        for (x = 0; x < codec_index; ++x) {
+                struct rtpPayloadType pt;
+                pt = ast_rtp_lookup_pt(p->rtp, codec_pt_order[x]);
+                if (!pt.isAstFormat && !pt.code && p->vrtp)
+                        pt = ast_rtp_lookup_pt(p->vrtp, codec_pt_order[x]);
+                if (pt.isAstFormat) {
+                        ast_codec_pref_append(&p->formats, pt.code);
+                }
+        }
+        ast_codec_pref_remove2(&p->formats, ~p->usercapability);
 	
 	if (udptlportno != -1) {
 		int found = 0, x;
@@ -4810,8 +4829,6 @@
 	ast_rtp_get_current_formats(newaudiortp, &peercapability, &peernoncodeccapability);
 	ast_rtp_get_current_formats(newvideortp, &vpeercapability, &vpeernoncodeccapability);
 
-	newjointcapability = p->capability & (peercapability | vpeercapability);
-	newpeercapability = (peercapability | vpeercapability);
 	newnoncodeccapability = noncodeccapability & peernoncodeccapability;
 		
 		
@@ -4820,17 +4837,17 @@
 		char s1[BUFSIZ], s2[BUFSIZ], s3[BUFSIZ], s4[BUFSIZ];
 
 		ast_verbose("Capabilities: us - %s, peer - audio=%s/video=%s, combined - %s\n",
-			ast_getformatname_multiple(s1, BUFSIZ, p->capability),
-			ast_getformatname_multiple(s2, BUFSIZ, newpeercapability),
+			ast_getformatname_multiple(s1, BUFSIZ, p->usercapability),
+			ast_getformatname_multiple(s2, BUFSIZ, peercapability),
 			ast_getformatname_multiple(s3, BUFSIZ, vpeercapability),
-			ast_getformatname_multiple(s4, BUFSIZ, newjointcapability));
+			ast_codec_pref_dump(s4, BUFSIZ, &p->formats));
 
 		ast_verbose("Non-codec capabilities (dtmf): us - %s, peer - %s, combined - %s\n",
 			ast_rtp_lookup_mime_multiple(s1, BUFSIZ, noncodeccapability, 0),
 			ast_rtp_lookup_mime_multiple(s2, BUFSIZ, peernoncodeccapability, 0),
 			ast_rtp_lookup_mime_multiple(s3, BUFSIZ, newnoncodeccapability, 0));
 	}
-	if (!newjointcapability) {
+	if (!ast_codec_pref_bits(&p->formats)) {
 		ast_log(LOG_NOTICE, "No compatible codecs, not accepting this offer!\n");
 		/* Do NOT Change current setting */
 		return -1;
@@ -4838,8 +4855,6 @@
 
 	/* We are now ready to change the sip session and p->rtp and p->vrtp with the offered codecs, since
 		they are acceptable */
-	p->jointcapability = newjointcapability;	/* Our joint codec profile for this call */
-	p->peercapability = newpeercapability;		/* The other sides capability in latest offer */
 	p->noncodeccapability = newnoncodeccapability;	/* DTMF capabilities */
 
 	ast_rtp_pt_copy(p->rtp, newaudiortp);
@@ -4873,24 +4888,13 @@
 	/* Ok, we're going with this offer */
 	if (option_debug > 1) {
 		char buf[BUFSIZ];
-		ast_log(LOG_DEBUG, "We're settling with these formats: %s\n", ast_getformatname_multiple(buf, BUFSIZ, p->jointcapability));
+		ast_log(LOG_DEBUG, "We're settling with these formats: %s\n", ast_codec_pref_dump(buf, BUFSIZ, &p->formats));
 	}
 
 	if (!p->owner) 	/* There's no open channel owning us so we can return here. For a re-invite or so, we proceed */
 		return 0;
 
-
-	if (!(p->owner->nativeformats & p->jointcapability & AST_FORMAT_AUDIO_MASK)) {
-		if (debug) {
-			char s1[BUFSIZ], s2[BUFSIZ];
-			ast_log(LOG_DEBUG, "Oooh, we need to change our audio formats since our peer supports only %s and not %s\n", 
-				ast_getformatname_multiple(s1, BUFSIZ, p->jointcapability),
-				ast_getformatname_multiple(s2, BUFSIZ, p->owner->nativeformats));
-		}
-		p->owner->nativeformats = ast_codec_choose(&p->prefs, p->jointcapability, 1) | (p->capability & vpeercapability);
-		ast_set_read_format(p->owner, p->owner->readformat);
-		ast_set_write_format(p->owner, p->owner->writeformat);
-	}
+	memcpy(&p->owner->nativeformats, &p->formats, sizeof(p->formats));
 
 	if ((bridgepeer = ast_bridged_channel(p->owner))) {
 		/* We have a bridge */
@@ -5528,8 +5532,10 @@
 
 	if (debug)
 		ast_verbose("Adding codec 0x%x (%s) to SDP\n", codec, ast_getformatname(codec));
-	if ((rtp_code = ast_rtp_lookup_code(p->rtp, 1, codec)) == -1)
-		return;
+	if ((rtp_code = ast_rtp_lookup_code(p->rtp, 1, codec)) == -1) {
+		if (!p->vrtp || (rtp_code = ast_rtp_lookup_code(p->vrtp, 1, codec)) == -1)
+			return;
+	}
 
 	ast_build_string(m_buf, m_size, " %d", rtp_code);
 	ast_build_string(a_buf, a_size, "a=rtpmap:%d %s/%d\r\n", rtp_code,
@@ -5731,9 +5737,10 @@
 
 	char iabuf[INET_ADDRSTRLEN];
 	int x;
-	int capability;
+	const struct ast_codec_pref *capability;
 	int needvideo = FALSE;
 	int debug = sip_debug_test_pvt(p);
+	int pref_codec;
 
 	m_video[0] = '\0';	/* Reset the video media string if it's not needed */
 
@@ -5741,6 +5748,7 @@
 		ast_log(LOG_WARNING, "No way to add SDP without an RTP structure\n");
 		return -1;
 	}
+	capability = &p->formats;
 
 	/* Set RTP Session ID and version */
 	if (!p->sessionid) {
@@ -5757,21 +5765,22 @@
 	/* Is this a re-invite to move the media out, then use the original offer from caller  */
 	if (p->redirip.sin_addr.s_addr) {
 		dest.sin_port = p->redirip.sin_port;
-		dest.sin_addr = p->redirip.sin_addr;
-		if (p->redircodecs)
-			capability = p->redircodecs;
+		if (ast_test_flag(&p->flags[0], SIP_NAT) & SIP_NAT_ROUTE)
+			dest.sin_addr = p->ourip;
+		else
+			dest.sin_addr = p->redirip.sin_addr;
+                if (ast_codec_pref_bits(&p->redircodecs)) {
+                        /* We are to get all compatible with redircodecs codecs */
+			capability = &p->redircodecs;
+                }
 	} else {
 		dest.sin_addr = p->ourip;
 		dest.sin_port = sin.sin_port;
 	}
 
-	/* Ok, let's start working with codec selection here */
-	capability = p->jointcapability;
-
 	if (option_debug > 1) {
 		char codecbuf[BUFSIZ];
-		ast_log(LOG_DEBUG, "** Our capability: %s Video flag: %s\n", ast_getformatname_multiple(codecbuf, sizeof(codecbuf), capability), ast_test_flag(&p->flags[0], SIP_NOVIDEO) ? "True" : "False");
-		ast_log(LOG_DEBUG, "** Our prefcodec: %s \n", ast_getformatname_multiple(codecbuf, sizeof(codecbuf), p->prefcodec));
+		ast_log(LOG_DEBUG, "** Our capability: %s Video flag: %s\n", ast_codec_pref_dump(codecbuf, sizeof(codecbuf), capability), ast_test_flag(&p->flags[0], SIP_NOVIDEO) ? "True" : "False");
 	}
 	
 	if ((ast_test_flag(&p->t38.t38support, SIP_PAGE2_T38SUPPORT_RTP))) {
@@ -5780,7 +5789,7 @@
 	}
 
 	/* Check if we need video in this call */
-	if((capability & AST_FORMAT_VIDEO_MASK) && !ast_test_flag(&p->flags[0], SIP_NOVIDEO)) {
+	if (capability->video_bits && !ast_test_flag(&p->flags[0], SIP_NOVIDEO)) {
 		if (p->vrtp) {
 			needvideo = TRUE;
 			if (option_debug > 1)
@@ -5811,8 +5820,8 @@
 			ast_verbose("Video is at %s port %d\n", ast_inet_ntoa(iabuf, sizeof(iabuf), p->ourip), ntohs(vsin.sin_port));	
 
 		/* For video, we can't negotiate video offers. Let's compare the incoming call with what we got. */
-		if (p->prefcodec) {
-			int videocapability = (capability & p->prefcodec) & AST_FORMAT_VIDEO_MASK; /* Outbound call */
+		if (p->formats.video_bits) {
+			int videocapability = p->formats.video_bits; /* Outbound call */
 		
 			/*! \todo XXX We need to select one codec, not many, since there's no transcoding */
 
@@ -5823,14 +5832,11 @@
 					ast_log(LOG_DEBUG, "** No compatible video codecs... Disabling video.\n");
 			} 
 
-			/* Replace video capabilities with the new videocapability */
-			capability = (capability & AST_FORMAT_AUDIO_MASK) | videocapability;
-
 			if (option_debug > 4) {
 				char codecbuf[BUFSIZ];
 				if (videocapability)
 					ast_log(LOG_DEBUG, "** Our video codec selection is: %s \n", ast_getformatname_multiple(codecbuf, sizeof(codecbuf), videocapability));
-				ast_log(LOG_DEBUG, "** Capability now set to : %s \n", ast_getformatname_multiple(codecbuf, sizeof(codecbuf), capability));
+				ast_log(LOG_DEBUG, "** Capability now set to : %s \n", ast_codec_pref_dump(codecbuf, sizeof(codecbuf), capability));
 			}
 		}
 	}
@@ -5860,53 +5866,79 @@
 	/* Prefer the audio codec we were requested to use, first, no matter what 
 		Note that p->prefcodec can include video codecs, so mask them out
 	 */
-	if (capability & p->prefcodec) {
-		add_codec_to_sdp(p, p->prefcodec & AST_FORMAT_AUDIO_MASK, 8000,
-				 &m_audio_next, &m_audio_left,
-				 &a_audio_next, &a_audio_left,
-				 debug);
-		alreadysent |= p->prefcodec & AST_FORMAT_AUDIO_MASK;
+	pref_codec = ast_codec_pref_index_audio(capability, 0);
+	if (pref_codec) {
+		add_codec_to_sdp(p, pref_codec, 8000,
+				&m_audio_next, &m_audio_left,
+				&a_audio_next, &a_audio_left,
+				debug);
+		alreadysent |= pref_codec;
+	}
+	pref_codec = ast_codec_pref_index_video(capability, 0);
+	if (pref_codec) {
+		add_codec_to_sdp(p, pref_codec, 90000,
+				&m_video_next, &m_video_left,
+				&a_video_next, &a_video_left,
+				debug);
+		alreadysent |= pref_codec;
 	}
 
 
 	/* Start by sending our preferred audio codecs */
 	for (x = 0; x < 32; x++) {
-		int pref_codec;
-
-		if (!(pref_codec = ast_codec_pref_index(&p->prefs, x)))
+		if (!(pref_codec = ast_codec_pref_index_audio(&p->userprefs, x)))
 			break; 
 
-		if (!(capability & pref_codec))
+		if (!(capability->audio_bits & pref_codec) ||
+		    (alreadysent & pref_codec))
+		{
 			continue;
+		}
+		add_codec_to_sdp(p, pref_codec, 8000,
+				&m_audio_next, &m_audio_left,
+				&a_audio_next, &a_audio_left,
+				debug);
+		alreadysent |= pref_codec;
+	}
+	for (x = 0; x < 32; x++) {
+		if (!(pref_codec = ast_codec_pref_index_video(&p->userprefs, x)))
+			break;
 
+		if (!(capability->video_bits & pref_codec) ||
+		    (alreadysent & pref_codec))
+		{
+			continue;
+		}
+		add_codec_to_sdp(p, pref_codec, 90000,
+				&m_video_next, &m_video_left,
+				&a_video_next, &a_video_left,
+				debug);
+		alreadysent |= pref_codec;
+	}
+	/* Now send any other common codecs, and non-codec formats: */
+	for (x = 0 ; x < 32 ; x++) {
+		if(!(pref_codec = ast_codec_pref_index_audio(capability, x)))
+			break;
 		if (alreadysent & pref_codec)
 			continue;
 
 		add_codec_to_sdp(p, pref_codec, 8000,
-				 &m_audio_next, &m_audio_left,
-				 &a_audio_next, &a_audio_left,
-				 debug);
+				&m_audio_next, &m_audio_left,
+				&a_audio_next, &a_audio_left,
+				debug);
 		alreadysent |= pref_codec;
 	}
-
-	/* Now send any other common audio and video codecs, and non-codec formats: */
-	for (x = 1; x <= (needvideo ? AST_FORMAT_MAX_VIDEO : AST_FORMAT_MAX_AUDIO); x <<= 1) {
-		if (!(capability & x))	/* Codec not requested */
-			continue;
-
-		if (alreadysent & x)	/* Already added to SDP */
+	for (x = 0; x < 32; x++) {
+		if (!(pref_codec = ast_codec_pref_index_video(&p->userprefs, x)))
+			break;
+		if (alreadysent & pref_codec)
 			continue;
 
-		if (x <= AST_FORMAT_MAX_AUDIO)
-			add_codec_to_sdp(p, x, 8000,
-					 &m_audio_next, &m_audio_left,
-					 &a_audio_next, &a_audio_left,
-					 debug);
-		else 
-			add_codec_to_sdp(p, x, 90000,
-					 &m_video_next, &m_video_left,
-					 &a_video_next, &a_video_left,
-					 debug);
+		add_codec_to_sdp(p, pref_codec, 90000,
+				&m_video_next, &m_video_left,
+				&a_video_next, &a_video_left,
+				debug);
+		alreadysent |= pref_codec;
 	}
 
 	/* Now add DTMF RFC2833 telephony-event as a codec */
@@ -5960,7 +5992,7 @@
 
 	if (option_debug > 2) {
 		char buf[BUFSIZ];
-		ast_log(LOG_DEBUG, "Done building SDP. Settling with this capability: %s\n", ast_getformatname_multiple(buf, BUFSIZ, capability));
+		ast_log(LOG_DEBUG, "Done building SDP. Settling with this capability: %s\n", ast_codec_pref_dump(buf, BUFSIZ, capability));
 	}
 
 	return 0;
@@ -8577,7 +8609,8 @@
 				p->chanvars = tmpvar;
 			}
 		}
-		p->prefs = user->prefs;
+		p->usercapability = user->capability;
+		p->userprefs = user->prefs;
 		/* replace callerid if rpid found, and not restricted */
 		if (!ast_strlen_zero(rpid_num) && ast_test_flag(&p->flags[0], SIP_TRUSTRPID)) {
 			char *tmp;
@@ -8641,12 +8674,8 @@
 			p->pickupgroup = user->pickupgroup;
 			if (user->callingpres)	/* User callingpres setting will override RPID header */
 				p->callingpres = user->callingpres;
+			ast_codec_pref_remove2(&p->formats, ~user->capability);
 			
-			/* Set default codec settings for this call */
-			p->capability = user->capability;		/* User codec choice */
-			p->jointcapability = user->capability;		/* Our codecs */
-			if (p->peercapability)				/* AND with peer's codecs */
-				p->jointcapability &= p->peercapability;
 			if ((ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_RFC2833) ||
 			    (ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_AUTO))
 				p->noncodeccapability |= AST_RTP_DTMF;
@@ -8774,11 +8803,8 @@
 				p->amaflags = peer->amaflags;
 				p->callgroup = peer->callgroup;
 				p->pickupgroup = peer->pickupgroup;
-				p->capability = peer->capability;
-				p->prefs = peer->prefs;
-				p->jointcapability = peer->capability;
-				if (p->peercapability)
-					p->jointcapability &= p->peercapability;
+				ast_codec_pref_remove2(&p->formats, ~peer->capability);
+				p->userprefs = peer->prefs;
 				p->maxcallbitrate = peer->maxcallbitrate;
 				if (!ast_test_flag(&p->flags[1], SIP_PAGE2_VIDEOSUPPORT) && p->vrtp) {
 					ast_rtp_destroy(p->vrtp);
@@ -9434,18 +9460,9 @@
 /*! \brief Print codec list from preference to CLI/manager */
 static void print_codec_to_cli(int fd, struct ast_codec_pref *pref)
 {
-	int x, codec;
-
-	for(x = 0; x < 32 ; x++) {
-		codec = ast_codec_pref_index(pref, x);
-		if (!codec)
-			break;
-		ast_cli(fd, "%s", ast_getformatname(codec));
-		if (x < 31 && ast_codec_pref_index(pref, x + 1))
-			ast_cli(fd, ",");
-	}
-	if (!x)
-		ast_cli(fd, "none");
+	char buf[512];
+	ast_codec_pref_dump(buf, sizeof(buf), pref);
+	ast_cli(fd, "%s", buf);
 }
 
 /*! \brief Print domain mode to cli */
@@ -9530,10 +9547,9 @@
 	char iabuf[INET_ADDRSTRLEN];
 	struct sip_peer *peer;
 	char codec_buf[512];
-	struct ast_codec_pref *pref;
 	struct ast_variable *v;
 	struct sip_auth *auth;
-	int x = 0, codec = 0, load_realtime;
+	int x, load_realtime;
 	int realtimepeers;
 
 	realtimepeers = ast_check_realtime("sippeers");
@@ -9629,10 +9645,9 @@
 		ast_cli(fd, "  Codecs       : ");
 		ast_getformatname_multiple(codec_buf, sizeof(codec_buf) -1, peer->capability);
 		ast_cli(fd, "%s\n", codec_buf);
-		ast_cli(fd, "  Codec Order  : (");
+		ast_cli(fd, "  Codec Order  : ");
 		print_codec_to_cli(fd, &peer->prefs);
-
-		ast_cli(fd, ")\n");
+		ast_cli(fd, "\n");
 
 		ast_cli(fd, "  Status       : ");
 		peer_status(peer, status, sizeof(status));
@@ -9696,17 +9711,8 @@
 		ast_getformatname_multiple(codec_buf, sizeof(codec_buf) -1, peer->capability);
 		astman_append(s, "%s\r\n", codec_buf);
 		astman_append(s, "CodecOrder: ");
-		pref = &peer->prefs;
-		for(x = 0; x < 32 ; x++) {
-			codec = ast_codec_pref_index(pref,x);
-			if (!codec)
-				break;
-			astman_append(s, "%s", ast_getformatname(codec));
-			if (x < 31 && ast_codec_pref_index(pref,x+1))
-				astman_append(s, ",");
-		}
-
-		astman_append(s, "\r\n");
+		ast_codec_pref_dump(codec_buf, sizeof(codec_buf), &peer->prefs);
+		astman_append(s, "%s\r\n", codec_buf);
 		astman_append(s, "Status: ");
 		peer_status(peer, status, sizeof(status));
 		astman_append(s, "%s\r\n", status);
@@ -9734,9 +9740,8 @@
 {
 	char cbuf[256];
 	struct sip_user *user;
-	struct ast_codec_pref *pref;
 	struct ast_variable *v;
-	int x = 0, codec = 0, load_realtime;
+	int load_realtime;
 
 	if (argc < 4)
 		return RESULT_SHOWUSAGE;
@@ -9765,20 +9770,9 @@
 		print_group(fd, user->pickupgroup, 0);
 		ast_cli(fd, "  Callerid     : %s\n", ast_callerid_merge(cbuf, sizeof(cbuf), user->cid_name, user->cid_num, "<unspecified>"));
 		ast_cli(fd, "  ACL          : %s\n", (user->ha?"Yes":"No"));
-		ast_cli(fd, "  Codec Order  : (");
-		pref = &user->prefs;
-		for(x = 0; x < 32 ; x++) {
-			codec = ast_codec_pref_index(pref,x);
-			if (!codec)
-				break;
-			ast_cli(fd, "%s", ast_getformatname(codec));
-			if (x < 31 && ast_codec_pref_index(pref,x+1))
-				ast_cli(fd, "|");
-		}
-
-		if (!x)
-			ast_cli(fd, "none");
-		ast_cli(fd, ")\n");
+		ast_cli(fd, "  Codec Order  : ");
+		print_codec_to_cli(fd, &user->prefs);
+		ast_cli(fd, "\n");
 
 		if (user->chanvars) {
  			ast_cli(fd, "  Variables    :\n");
@@ -9986,7 +9980,7 @@
 				S_OR(cur->username, S_OR(cur->cid_num, "(None)")),
 				cur->callid, 
 				cur->ocseq, cur->icseq, 
-				ast_getformatname(cur->owner ? cur->owner->nativeformats : 0), 
+				ast_getformatname(cur->owner ? ast_codec_pref_index_audio(&cur->owner->nativeformats, 0)	: 0), 
 				ast_test_flag(&cur->flags[0], SIP_CALL_ONHOLD) ? "Yes" : "No",
 				ast_test_flag(&cur->flags[0], SIP_NEEDDESTROY) ? "(d)" : "",
 				cur->lastmsg ,
@@ -10155,6 +10149,7 @@
 	char iabuf[INET_ADDRSTRLEN];
 	size_t len;
 	int found = 0;
+	char buf[512];
 
 	if (argc != 4)
 		return RESULT_SHOWUSAGE;
@@ -10162,7 +10157,6 @@
 	ast_mutex_lock(&iflock);
 	for (cur = iflist; cur; cur = cur->next) {
 		if (!strncasecmp(cur->callid, argv[3], len)) {
-			char formatbuf[BUFSIZ/2];
 			ast_cli(fd,"\n");
 			if (cur->subscribed != NONE)
 				ast_cli(fd, "  * Subscription (type: %s)\n", subscription_type2str(cur->subscribed));
@@ -10171,11 +10165,8 @@
 			ast_cli(fd, "  Direction:              %s\n", ast_test_flag(&cur->flags[0], SIP_OUTGOING)?"Outgoing":"Incoming");
 			ast_cli(fd, "  Call-ID:                %s\n", cur->callid);
 			ast_cli(fd, "  Owner channel ID:       %s\n", cur->owner ? cur->owner->name : "<none>");
-			ast_cli(fd, "  Our Codec Capability:   %d\n", cur->capability);
 			ast_cli(fd, "  Non-Codec Capability (DTMF):   %d\n", cur->noncodeccapability);
-			ast_cli(fd, "  Their Codec Capability:   %d\n", cur->peercapability);
-			ast_cli(fd, "  Joint Codec Capability:   %d\n", cur->jointcapability);
-			ast_cli(fd, "  Format:                 %s\n", ast_getformatname_multiple(formatbuf, sizeof(formatbuf), cur->owner ? cur->owner->nativeformats : 0) );
+			ast_cli(fd, "  Formats                 %s\n", cur->owner ? ast_codec_pref_dump(buf, sizeof(buf), &cur->owner->nativeformats) : "Unknown");
 			ast_cli(fd, "  MaxCallBR:              %d kbps\n", cur->maxcallbitrate);
 			ast_cli(fd, "  Theoretical Address:    %s:%d\n", ast_inet_ntoa(iabuf, sizeof(iabuf), cur->sa.sin_addr), ntohs(cur->sa.sin_port));
 			ast_cli(fd, "  Received Address:       %s:%d\n", ast_inet_ntoa(iabuf, sizeof(iabuf), cur->recv.sin_addr), ntohs(cur->recv.sin_port));
